/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controller;

import domain.Invoice;
import domain.Manufacturer;
import domain.Product;
import domain.User;
import java.util.List;
import service.ServiceInvoice;
import service.ServiceManufacturer;
import service.impl.ServiceInvoiceImpl;
import service.impl.ServiceManufacturerImpl;
import storage.StorageManufacturer;
import storage.StorageProduct;
import storage.StorageUser;
import storage.impl.database.StorageDatabaseManufacturer;
import storage.impl.database.StorageDatabaseProduct;
import storage.impl.memory.StorageMemoryManufacturer;
import storage.impl.memory.StorageMemoryProduct;
import storage.impl.memory.StorageMemoryUser;

/**
 *
 * @author student1
 */
public class Controller {
    private static Controller instance;
    private StorageUser storageUser;
    //private StorageManufacturer storageManufacturer;
    private ServiceManufacturer serviceManufacturer;
    private ServiceInvoice serviceInvoice;
    private StorageProduct storageProduct;

    private Controller() {
        storageUser=new StorageMemoryUser();
        //storageManufacturer=new StorageDatabaseManufacturer();
        storageProduct=new StorageDatabaseProduct();
        serviceManufacturer=new ServiceManufacturerImpl();
        serviceInvoice=new ServiceInvoiceImpl();
    }
    
    public static Controller getInstance(){
        if(instance==null){
            instance=new Controller();
        }
        return instance;
    }
    
    public User logIn(String username, String password) throws Exception{
        List<User> users=storageUser.getAll();
        for (User user : users) {
            if(user.getUsername().equalsIgnoreCase(username)){
                if(user.getPassword().equals(password)){
                    return user;
                }else{
                    throw new Exception("Lozinka nije odgovarajuća!");
                }
            }
        }
        throw new Exception("Korisnik nije registrovan!");
    }
    
    public List<Manufacturer> getAllManufacturers() throws Exception{
        //return storageManufacturer.getAll();
        return serviceManufacturer.getAll();
    }
    
    public void saveProduct(Product product) throws Exception{
        storageProduct.insert(product);
        
    }
    
    public List<Product> getAllProducts() throws Exception{
        return storageProduct.getAll();
    }
    
    public Invoice saveInvoice(Invoice invoice) throws Exception{
        return serviceInvoice.save(invoice);
    }
    
    
}
