/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package server;

import controller.Controller;
import domain.User;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import transfer.RequestObject;
import transfer.ResponseObject;
import util.Operation;

/**
 *
 * @author student1
 */
public class Server {
    ServerSocket serverSocket;
    Socket socket;

    public Server() {
    }
    
    
    public void start() throws IOException, ClassNotFoundException{
        serverSocket=new ServerSocket(9000);
        System.out.println("waiting...");
        socket=serverSocket.accept();
        System.out.println("Client connected!");
        
        handleClient();
    }
    
    public void handleClient() throws IOException, ClassNotFoundException{
        RequestObject request=null;
        ResponseObject response=null;
        while(true){
            request=receiveRequest();
            switch(request.getOperation()){
                case Operation.OPERATION_LOGIN:
                    response=operationLogIn(request);
                    break;
            }
            sendResponse(response);
        }
    }
    
    public RequestObject receiveRequest() throws IOException, ClassNotFoundException{
        ObjectInputStream in=new ObjectInputStream(socket.getInputStream());
        return (RequestObject)in.readObject();
    }
    
    public void sendResponse(ResponseObject response) throws IOException{
        ObjectOutputStream out=new ObjectOutputStream(socket.getOutputStream());
        out.writeObject(response);
        out.flush();
    }
    
    
    public ResponseObject operationLogIn(RequestObject request){
        ResponseObject response=null;
        Map<String, String> data=(Map)request.getData();
        String username=data.get("username");
        String password=data.get("password");

        try {
            response=new ResponseObject();
            User user=Controller.getInstance().logIn(username, password);
            response.setData(user);
        } catch (Exception ex) {
            ex.printStackTrace();
            response.setException(ex);
        }
        return response;
    }
}
